// Sum.h : Declaration of the CSum

#pragma once
#include "resource.h"       // main symbols


// ISum
[
	object,
	uuid("087A1119-8D78-42BD-9175-4D120C445EDA"),
	dual,	helpstring("ISum Interface"),
	pointer_default(unique)
]
__interface ISum : IDispatch
{
  [id(1), helpstring("method Add")] HRESULT Add(SHORT iOp1, SHORT iOp2, [out][retval]SHORT* piTotal);
  [id(2), helpstring("method Accumulate")] HRESULT Accumulate(SHORT iValue, [out][retval]SHORT* piTotal);
};



// CSum

[
	coclass,
	threading("apartment"),
	vi_progid("Stateful.Sum"),
	progid("Stateful.Sum.1"),
	version(1.0),
	uuid("05C99969-C6E4-457D-81EA-BF2CCF4FB8B3"),
	helpstring("Sum Class")
]
class ATL_NO_VTABLE CSum : 
	public ISum
{
public:
  CSum() : m_iTotal(0)
	{
	}

protected:
  int m_iTotal;

public:
	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:

  STDMETHOD(Add)(SHORT iOp1, SHORT iOp2, SHORT* piTotal);
  STDMETHOD(Accumulate)(SHORT iValue, SHORT* piTotal);
};

